package hr.genetics.models;

import java.util.List;

import hr.geometrics.Direction;
import hr.geometrics.Line;
import hr.geometrics.Point;
import hr.geometrics.Vector;

public class Sensor {

	SimulationModel attachedTo = null;
	
	/**
	 * Angle, relative to vechile (from -pi/2 to pi/2)
	 */
	private double angle = 0;
	
	public Sensor(SimulationModel vechile, double angle) {
		
		this.attachedTo = vechile;
		this.angle = angle;
		
	}
	
	public Double getValue() {
				
		Direction direction = new Direction(
				this.attachedTo.getPosition(),
				this.attachedTo.getAngle() + this.angle
		);
		
		double distance = Double.POSITIVE_INFINITY;
		double currentDistance = 0;
		List<Line> lines = this.attachedTo.getEnvironment().getLines();
		Point possibleIntersection = null;
		
		for (int i = 0; i < lines.size(); ++i) {
			possibleIntersection = direction.getIntersectionWith(lines.get(i));
			
			if (possibleIntersection !=  null) {
				Vector testVector = new Vector(
						possibleIntersection.getX()-this.attachedTo.getPosition().getX(),
						possibleIntersection.getY()-this.attachedTo.getPosition().getY()
				);
				if (this.getDirectionVector().scalarProduct(testVector) >= 0) {
					if ((currentDistance = possibleIntersection.distanceFrom(this.attachedTo.getPosition()))
							< distance) {
						distance = currentDistance;
					}
				}
			} 
		}
		
		
		if (Double.isInfinite(distance)) {
			distance = this.attachedTo.getPosition().getY();
		}
				
		return distance;
		
	}
	
	public Vector getDirectionVector() {
		
		double angle = this.angle + this.attachedTo.getSpeed().getAngle();
		return new Vector( Math.cos(angle), Math.sin(angle) );
		
	}
	
}
